scala.tools.nsc.backend.jvm.BTypes

# ArrayBType

#### case class ArrayBType(componentType: BType) extends RefBType with Product with Serializable

Source
  BTypes.scala

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, RefBType, BType, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ArrayBType
2. Serializable
3. Serializable
4. Product
5. Equals
6. RefBType
7. BType
8. AnyRef
9. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new ArrayBType(componentType: BType)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ArrayBType to any2stringadd[ArrayBType] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ArrayBType, B)

   Implicit information
     This member is added by an implicit conversion from ArrayBType to ArrowAssoc[ArrayBType] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### def asArrayBType: ArrayBType

   Definition Classes
     BType

7. #### def asClassBType: ClassBType

   Definition Classes
     BType

8. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

9. #### def asPrimitiveBType: PrimitiveBType

   Definition Classes
     BType

10. #### def asRefBType: RefBType

    Definition Classes
      BType

11. #### def classOrArrayType: String

    The class or array type of this reference type.

    The class or array type of this reference type. Used for ANEWARRAY, MULTIANEWARRAY, INSTANCEOF and CHECKCAST instructions. Also used for emitting invokevirtual calls to (a: Array[T]).clone() for any T, see genApply.

    In contrast to the descriptor, this string does not contain the surrounding 'L' and ';' for class types, for example "java/lang/String". However, for array types, the full descriptor is used, for example "[Ljava/lang/String;".

    This can be verified for example using javap or ASMifier.

    Definition Classes
      RefBType

12. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

13. #### val componentType: BType

14. #### final def conformsTo(other: BType): Boolean

    Definition Classes
      BType

15. #### final def descriptor: String

    returns

      The Java descriptor of this type. Examples:

      - int: I
      - java.lang.String: Ljava/lang/String;
      - int[]: [I
      - Object m(String s, double d): (Ljava/lang/String;D)Ljava/lang/Object;
    Definition Classes
      BType

16. #### def dimension: Int

17. #### def elementType: BType

18. #### def ensuring(cond: (ArrayBType) ⇒ Boolean, msg: ⇒ Any): ArrayBType

    Implicit information
      This member is added by an implicit conversion from ArrayBType to Ensuring[ArrayBType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: (ArrayBType) ⇒ Boolean): ArrayBType

    Implicit information
      This member is added by an implicit conversion from ArrayBType to Ensuring[ArrayBType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: Boolean, msg: ⇒ Any): ArrayBType

    Implicit information
      This member is added by an implicit conversion from ArrayBType to Ensuring[ArrayBType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### def ensuring(cond: Boolean): ArrayBType

    Implicit information
      This member is added by an implicit conversion from ArrayBType to Ensuring[ArrayBType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

22. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

23. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

24. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ArrayBType to StringFormat[ArrayBType] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

25. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

26. #### final def isArray: Boolean

    Definition Classes
      BType

27. #### final def isBoxed: Boolean

    Definition Classes
      BType

28. #### final def isClass: Boolean

    Definition Classes
      BType

29. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

30. #### final def isIntSizedType: Boolean

    Definition Classes
      BType

31. #### final def isIntegralType: Boolean

    Definition Classes
      BType

32. #### final def isMethod: Boolean

    Definition Classes
      BType

33. #### final def isNonVoidPrimitiveType: Boolean

    Definition Classes
      BType

34. #### final def isNothingType: Boolean

    Definition Classes
      BType

35. #### final def isNullType: Boolean

    Definition Classes
      BType

36. #### final def isNumericType: Boolean

    Definition Classes
      BType

37. #### final def isPrimitive: Boolean

    Definition Classes
      BType

38. #### final def isRealType: Boolean

    Definition Classes
      BType

39. #### final def isRef: Boolean

    Definition Classes
      BType

40. #### final def isWideType: Boolean

    Definition Classes
      BType

41. #### final def maxType(other: BType): BType

    Compute the upper bound of two types.

    Compute the upper bound of two types. Takes promotions of numeric primitives into account.

    Definition Classes
      BType

42. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

43. #### final def notify(): Unit

    Definition Classes
      AnyRef

44. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

45. #### final def size: Int

    returns

      0 for void, 2 for long and double, 1 otherwise

    Definition Classes
      BType

46. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

47. #### def toASMType: Type

    The asm.Type corresponding to this BType.

    The asm.Type corresponding to this BType.

    Note about asm.Type.getObjectType (*): For class types, the method expects the internal name, i.e. without the surrounding 'L' and ';'. For array types on the other hand, the method expects a full descriptor, for example "[Ljava/lang/String;".

    See method asm.Type.getType that creates a asm.Type from a type descriptor

    - for an OBJECT type, the 'L' and ';' are not part of the range of the created Type
    - for an ARRAY type, the full descriptor is part of the range
    Definition Classes
      BType

48. #### final def toString(): String

    Definition Classes
      BType → AnyRef → Any

49. #### final def typedOpcode(opcode: Int): Int

    Some JVM opcodes have typed variants.

    Some JVM opcodes have typed variants. This method returns the correct opcode according to the type.

    opcode

      A JVM instruction opcode. This opcode must be one of ILOAD, ISTORE, IALOAD, IASTORE, IADD, ISUB, IMUL, IDIV, IREM, INEG, ISHL, ISHR, IUSHR, IAND, IOR IXOR and IRETURN.

    returns

      The opcode adapted to this java type. For example, if this type is `float` and `opcode` is `IRETURN`, this method returns `FRETURN`.

    Definition Classes
      BType

50. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

51. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

52. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

53. #### def →[B](y: B): (ArrayBType, B)

    Implicit information
      This member is added by an implicit conversion from ArrayBType to ArrowAssoc[ArrayBType] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from RefBType

### Inherited from BType

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ArrayBType to any2stringadd[ArrayBType]

### Inherited by implicit conversion StringFormat from ArrayBType to StringFormat[ArrayBType]

### Inherited by implicit conversion Ensuring from ArrayBType to Ensuring[ArrayBType]

### Inherited by implicit conversion ArrowAssoc from ArrayBType to ArrowAssoc[ArrayBType]

### Ungrouped